Index: core/gui_lang.h
===================================================================
--- core/gui_lang.h	(Revision 701)
+++ core/gui_lang.h	(Arbeitskopie)
@@ -563,9 +563,11 @@
 #define LANG_MENU_RESET_FILES         451
 #define LANG_MENU_RESTART_CAMERA         452
 #define LANG_MENU_FLASH_MANUAL_OVERRIDE        453
+#define LANG_XXX_PROPCOMPARE		454
+#define LANG_XXX_PARAMCOMPARE		455
 //-------------------------------------------------------------------
 
-#define GUI_LANG_ITEMS                  453
+#define GUI_LANG_ITEMS                  455
 
 //-------------------------------------------------------------------
 extern void gui_lang_init();
Index: core/gui_space.c
===================================================================
--- core/gui_space.c	(Revision 701)
+++ core/gui_space.c	(Arbeitskopie)
@@ -18,7 +18,7 @@
 }
 
 static void gui_space_draw_spacebar_horizontal () {
-    coord x;
+    int x;
     color cl = conf.space_color;
     int perc = get_space_perc(),height = 2;
     float size = 0;
@@ -26,7 +26,7 @@
     cl = (perc<=conf.space_perc_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 1){
-    cl = (GetFreeCardSpaceKb()/1024<=conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
+    cl = (GetFreeCardSpaceKb()/1024<=(unsigned)conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 2){
     cl = conf.space_color;
@@ -71,7 +71,7 @@
 
 
 static void gui_space_draw_spacebar_vertical () {
-    coord y;
+    int y;
     color cl = conf.space_color;
     int perc = get_space_perc(), width = 2;
     float size = 0;
@@ -79,7 +79,7 @@
     cl = (perc<=conf.space_perc_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 1){
-    cl = (GetFreeCardSpaceKb()/1024<=conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
+    cl = (GetFreeCardSpaceKb()/1024<=(unsigned)conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 2){
     cl = conf.space_color;
@@ -126,14 +126,14 @@
 }
 
 static void gui_space_draw_icon () {
-    coord x;
+    int x;
     color cl = conf.space_color;
     int perc = get_space_perc();
     if (conf.space_warn_type == 0){
     cl = (perc<=conf.space_perc_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 1){
-    cl = (GetFreeCardSpaceKb()/1024<=conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
+    cl = (GetFreeCardSpaceKb()/1024<=(unsigned)conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 2){
     cl = conf.space_color;
@@ -182,7 +182,7 @@
     cl = (perc<=conf.space_perc_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 1){
-    cl = (GetFreeCardSpaceKb()/1024<=conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
+    cl = (GetFreeCardSpaceKb()/1024<=(unsigned)conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 2){
     cl = conf.space_color;
@@ -200,7 +200,7 @@
     cl = (perc<=conf.space_perc_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 1){
-    cl = (GetFreeCardSpaceKb()/1024<=conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
+    cl = (GetFreeCardSpaceKb()/1024<=(unsigned)conf.space_mb_warn)?conf.osd_color_warn:(conf.space_color);
     }
     if (conf.space_warn_type == 2){
     cl = conf.space_color;
Index: core/edgeoverlay.c
===================================================================
--- core/edgeoverlay.c	(Revision 701)
+++ core/edgeoverlay.c	(Arbeitskopie)
@@ -178,7 +178,7 @@
 
 	static int shotTaken = 0;
 	static int imgmem = 0;
-	static int ymin = 0;
+	static unsigned int ymin = 0;
 	static int thresh;
 	thresh = conf.edge_overlay_thresh; //40
 	static int xoffset = 0;
@@ -187,7 +187,8 @@
 	static char strbuf[7] = "Frozen";
 	static unsigned char *img;
 	int i, hi, c;
-	int x, y, h, v, ymax, y1, x1, y2;
+	unsigned ymax, x, y, y1, x1;
+	int h, v, y2;
 	const char * ptrh1;
 	const char * ptrh2;
 	const char * ptrv1;
Index: core/gui_read.c
===================================================================
--- core/gui_read.c	(Revision 701)
+++ core/gui_read.c	(Arbeitskopie)
@@ -19,7 +19,7 @@
 #define READ_BUFFER_SIZE  100
 static char buffer[READ_BUFFER_SIZE+1];
 static long last_time;
-static int xx, yy;
+static unsigned int xx, yy;
 static int pause;
 
 //-------------------------------------------------------------------
@@ -83,7 +83,7 @@
 
 //-------------------------------------------------------------------
 static int read_fit_next_char(int ch) {
-    return (xx+rbf_char_width(ch) < x+w);
+    return ((unsigned)(xx+rbf_char_width(ch)) < x+w);
 }
 
 //-------------------------------------------------------------------
@@ -142,7 +142,7 @@
                                         ll+=rbf_char_width(buffer[ii]);
                                     }
                                 }
-                                if (xx+ll>=x+w && ll<w) {
+                                if (xx+ll>=x+w && (unsigned)ll<w) {
                                     read_goto_next_line();
                                     continue;
                                 }
Index: core/gui.c
===================================================================
--- core/gui.c	(Revision 701)
+++ core/gui.c	(Arbeitskopie)
@@ -46,7 +46,7 @@
 //-------------------------------------------------------------------
 
 #define OPTIONS_AUTOSAVE
-#define SPLASH_TIME               20
+#define SPLASH_TIME               5 // XXX A configure option for this would be great
 
 int script_params_has_changed=0;
 //shortcuts
@@ -156,6 +156,7 @@
 static void gui_menuproc_edge_free(int arg);
 #ifdef OPT_DEBUGGING
 void gui_compare_props(int arg);
+void gui_compare_params(int arg);
 #endif
 #ifndef OPTIONS_AUTOSAVE
 static void gui_menuproc_save(int arg);
@@ -422,6 +423,8 @@
     {0x2a,LANG_MENU_MAIN_DEBUG,              MENUITEM_SUBMENU,   (int*)&debug_submenu },
 #endif
     {0x86,LANG_MENU_REMOTE_PARAM,            MENUITEM_SUBMENU,   (int*)&remote_submenu },
+    {0x80,LANG_XXX_PROPCOMPARE,        MENUITEM_PROC,    (int*)gui_compare_props},
+    {0x80,LANG_XXX_PARAMCOMPARE,        MENUITEM_PROC,   (int*)gui_compare_params},
 #if defined (DNG_EXT_FROM)
     {0x71,LANG_MENU_DNG_VIA_USB,        MENUITEM_BOOL | MENUITEM_ARG_CALLBACK, &conf.dng_usb_ext , (int)cb_change_dng_usb_ext},
 #endif
@@ -991,7 +994,7 @@
     conf.curve_enable+=change;
     if (conf.curve_enable<0)
         conf.curve_enable=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.curve_enable>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.curve_enable>=(sizeof(modes)/sizeof(modes[0])))
         conf.curve_enable=0;
 
 	if(change)
@@ -1006,7 +1009,7 @@
     conf.script_startup+=change;
     if (conf.script_startup<0)
         conf.script_startup=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.script_startup>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.script_startup>=(sizeof(modes)/sizeof(modes[0])))
         conf.script_startup=0;
 
     return modes[conf.script_startup];
@@ -1023,7 +1026,7 @@
         conf.script_param_set += change;
         if (conf.script_param_set < 0)
             conf.script_param_set = (sizeof(modes)/sizeof(modes[0]))-1;
-        else if (conf.script_param_set >= (sizeof(modes)/sizeof(modes[0])))
+        else if ((unsigned)conf.script_param_set >= (sizeof(modes)/sizeof(modes[0])))
             conf.script_param_set=0;
 
         if (!load_params_values(conf.script_file, 1, 0))
@@ -1042,7 +1045,7 @@
     conf.override_disable+=change;
     if (conf.override_disable<0)
         conf.override_disable=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.override_disable>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.override_disable>=(sizeof(modes)/sizeof(modes[0])))
         conf.override_disable=0;
 
     return modes[conf.override_disable];
@@ -1055,7 +1058,7 @@
     conf.histo_mode+=change;
     if (conf.histo_mode<0)
         conf.histo_mode=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.histo_mode>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.histo_mode>=(sizeof(modes)/sizeof(modes[0])))
         conf.histo_mode=0;
 
     histogram_set_mode(conf.histo_mode);
@@ -1070,7 +1073,7 @@
     conf.show_temp+=change;
     if (conf.show_temp<0)
         conf.show_temp=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_temp>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_temp>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_temp=0;
 
     return modes[conf.show_temp];
@@ -1083,7 +1086,7 @@
     conf.histo_layout+=change;
     if (conf.histo_layout<0)
         conf.histo_layout=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.histo_layout>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.histo_layout>=(sizeof(modes)/sizeof(modes[0])))
         conf.histo_layout=0;
 
     if (conf.histo_layout==OSD_HISTO_LAYOUT_Y || conf.histo_layout==OSD_HISTO_LAYOUT_Y_argb) {
@@ -1102,7 +1105,7 @@
     conf.font_cp+=change;
     if (conf.font_cp<0)
         conf.font_cp=(sizeof(fonts)/sizeof(fonts[0]))-1;
-    else if (conf.font_cp>=(sizeof(fonts)/sizeof(fonts[0])))
+    else if ((unsigned)conf.font_cp>=(sizeof(fonts)/sizeof(fonts[0])))
         conf.font_cp=0;
 
     if (change != 0) {
@@ -1167,7 +1170,7 @@
     conf.raw_nr+=change;
     if (conf.raw_nr<0)
         conf.raw_nr=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.raw_nr>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.raw_nr>=(sizeof(modes)/sizeof(modes[0])))
         conf.raw_nr=0;
 
     return modes[conf.raw_nr];
@@ -1181,7 +1184,7 @@
     conf.reader_codepage+=change;
     if (conf.reader_codepage<0)
         conf.reader_codepage=(sizeof(cps)/sizeof(cps[0]))-1;
-    else if (conf.reader_codepage>=(sizeof(cps)/sizeof(cps[0])))
+    else if ((unsigned)conf.reader_codepage>=(sizeof(cps)/sizeof(cps[0])))
         conf.reader_codepage=0;
 
     return cps[conf.reader_codepage];
@@ -1194,7 +1197,7 @@
     conf.autoiso_shutter+=change;
     if (conf.autoiso_shutter<0)
         conf.autoiso_shutter=(sizeof(shutter)/sizeof(shutter[0]))-1;
-    else if (conf.autoiso_shutter>=(sizeof(shutter)/sizeof(shutter[0])))
+    else if ((unsigned)conf.autoiso_shutter>=(sizeof(shutter)/sizeof(shutter[0])))
         conf.autoiso_shutter=0;
 
     return shutter[conf.autoiso_shutter];
@@ -1207,7 +1210,7 @@
     conf.zebra_mode+=change;
     if (conf.zebra_mode<0)
         conf.zebra_mode=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.zebra_mode>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.zebra_mode>=(sizeof(modes)/sizeof(modes[0])))
         conf.zebra_mode=0;
 
     return modes[conf.zebra_mode];
@@ -1220,7 +1223,7 @@
     conf.zebra_draw_osd+=change;
     if (conf.zebra_draw_osd<0)
         conf.zebra_draw_osd=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.zebra_draw_osd>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.zebra_draw_osd>=(sizeof(modes)/sizeof(modes[0])))
         conf.zebra_draw_osd=0;
 
     return modes[conf.zebra_draw_osd];
@@ -1233,7 +1236,7 @@
     conf.zoom_value+=change;
     if (conf.zoom_value<0)
         conf.zoom_value=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.zoom_value>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.zoom_value>=(sizeof(modes)/sizeof(modes[0])))
         conf.zoom_value=0;
 
     return modes[conf.zoom_value];
@@ -1245,7 +1248,7 @@
     conf.show_values+=change;
     if (conf.show_values<0)
         conf.show_values=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_values>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_values>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_values=0;
 
     return modes[conf.show_values];
@@ -1257,7 +1260,7 @@
     conf.nd_filter_state+=change;
     if (conf.nd_filter_state<0)
         conf.nd_filter_state=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.nd_filter_state>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.nd_filter_state>=(sizeof(modes)/sizeof(modes[0])))
         conf.nd_filter_state=0;
 
     return modes[conf.nd_filter_state];
@@ -1271,7 +1274,7 @@
     conf.show_dof+=change;
     if (conf.show_dof<0)
         conf.show_dof=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_dof>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_dof>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_dof=0;
 
     return modes[conf.show_dof];
@@ -1284,7 +1287,7 @@
     conf.show_histo+=change;
     if (conf.show_histo<0)
         conf.show_histo=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_histo>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_histo>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_histo=0;
 
     return modes[conf.show_histo];
@@ -1296,7 +1299,7 @@
     conf.show_clock+=change;
     if (conf.show_clock<0)
         conf.show_clock=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.show_clock>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.show_clock>=(sizeof(modes)/sizeof(modes[0])))
         conf.show_clock=0;
 
     return modes[conf.show_clock];
@@ -1308,7 +1311,7 @@
     conf.hide_osd+=change;
     if (conf.hide_osd<0)
         conf.hide_osd=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.hide_osd>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.hide_osd>=(sizeof(modes)/sizeof(modes[0])))
         conf.hide_osd=0;
 
     return modes[conf.hide_osd];
@@ -1320,7 +1323,7 @@
     conf.clock_format+=change;
     if (conf.clock_format<0)
         conf.clock_format=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.clock_format>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.clock_format>=(sizeof(modes)/sizeof(modes[0])))
         conf.clock_format=0;
 
     return modes[conf.clock_format];
@@ -1332,7 +1335,7 @@
     conf.clock_indicator+=change;
     if (conf.clock_indicator<0)
         conf.clock_indicator=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.clock_indicator>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.clock_indicator>=(sizeof(modes)/sizeof(modes[0])))
         conf.clock_indicator=0;
 
     return modes[conf.clock_indicator];
@@ -1344,7 +1347,7 @@
     conf.clock_halfpress+=change;
     if (conf.clock_halfpress<0)
         conf.clock_halfpress=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.clock_halfpress>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.clock_halfpress>=(sizeof(modes)/sizeof(modes[0])))
         conf.clock_halfpress=0;
 
     return modes[conf.clock_halfpress];
@@ -1356,7 +1359,7 @@
     conf.space_bar_show+=change;
     if (conf.space_bar_show<0)
         conf.space_bar_show=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_bar_show>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_bar_show>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_bar_show=0;
 
     return modes[conf.space_bar_show];
@@ -1368,7 +1371,7 @@
     conf.space_bar_size+=change;
     if (conf.space_bar_size<0)
         conf.space_bar_size=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_bar_size>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_bar_size>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_bar_size=0;
 
     return modes[conf.space_bar_size];
@@ -1380,7 +1383,7 @@
     conf.space_bar_width+=change;
     if (conf.space_bar_width<0)
         conf.space_bar_width=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_bar_width>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_bar_width>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_bar_width=0;
 
     return modes[conf.space_bar_width];
@@ -1392,7 +1395,7 @@
     conf.space_warn_type+=change;
     if (conf.space_warn_type<0)
         conf.space_warn_type=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.space_warn_type>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.space_warn_type>=(sizeof(modes)/sizeof(modes[0])))
         conf.space_warn_type=0;
 
     return modes[conf.space_warn_type];
@@ -1404,7 +1407,7 @@
      conf.show_movie_time+=change;
      if (conf.show_movie_time<0)
          conf.show_movie_time=(sizeof(modes)/sizeof(modes[0]))-1;
-     else if (conf.show_movie_time>=(sizeof(modes)/sizeof(modes[0])))
+     else if ((unsigned)conf.show_movie_time>=(sizeof(modes)/sizeof(modes[0])))
          conf.show_movie_time=0;
  
      return modes[conf.show_movie_time];
@@ -1458,7 +1461,7 @@
     conf.alt_prevent_shutdown+=change;
     if (conf.alt_prevent_shutdown<0)
         conf.alt_prevent_shutdown=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.alt_prevent_shutdown>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.alt_prevent_shutdown>=(sizeof(modes)/sizeof(modes[0])))
         conf.alt_prevent_shutdown=0;
 
     return modes[conf.alt_prevent_shutdown];
@@ -1468,7 +1471,7 @@
     conf.fast_ev_step+=change;
     if (conf.fast_ev_step<0)
         conf.fast_ev_step=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.fast_ev_step>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.fast_ev_step>=(sizeof(modes)/sizeof(modes[0])))
         conf.fast_ev_step=0;
     return modes[conf.fast_ev_step];
 }
@@ -1478,7 +1481,7 @@
     conf.video_mode+=change;
     if (conf.video_mode<0)
         conf.video_mode=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.video_mode>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.video_mode>=(sizeof(modes)/sizeof(modes[0])))
         conf.video_mode=0;
 
     return modes[conf.video_mode];
@@ -1505,7 +1508,7 @@
     conf.tv_bracket_value+=change;
     if (conf.tv_bracket_value<0)
         conf.tv_bracket_value=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.tv_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.tv_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
         conf.tv_bracket_value=0;
 
     return modes[conf.tv_bracket_value]; 
@@ -1517,7 +1520,7 @@
     conf.av_bracket_value+=change;
     if (conf.av_bracket_value<0)
         conf.av_bracket_value=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.av_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.av_bracket_value>=(sizeof(modes)/sizeof(modes[0])))
         conf.av_bracket_value=0;
 
     return modes[conf.av_bracket_value]; 
@@ -1529,7 +1532,7 @@
     conf.subj_dist_bracket_koef+=change;
     if (conf.subj_dist_bracket_koef<0)
         conf.subj_dist_bracket_koef=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.subj_dist_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.subj_dist_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.subj_dist_bracket_koef=0;
     
     return modes[conf.subj_dist_bracket_koef]; 
@@ -1541,7 +1544,7 @@
     conf.iso_bracket_koef+=change;
     if (conf.iso_bracket_koef<0)
         conf.iso_bracket_koef=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.iso_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.iso_bracket_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.iso_bracket_koef=0;
     
     return modes[conf.iso_bracket_koef]; 
@@ -1553,7 +1556,7 @@
     conf.bracket_type+=change;
     if (conf.bracket_type<0)
         conf.bracket_type=0;
-    else if (conf.bracket_type>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.bracket_type>=(sizeof(modes)/sizeof(modes[0])))
         conf.bracket_type=sizeof(modes)/sizeof(modes[0])-1;
 
     return modes[conf.bracket_type]; 
@@ -1573,7 +1576,7 @@
    else {
     if (conf.tv_override_koef<0)
         conf.tv_override_koef=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.tv_override_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.tv_override_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.tv_override_koef=0;
     }
     
@@ -1589,7 +1592,7 @@
        if (conf.tv_override_value<0) {
           conf.tv_override_value=sizeof(modes)/sizeof(modes[0])-1;
         }
-       else if (conf.tv_override_value>=(sizeof(modes)/sizeof(modes[0])))
+       else if ((unsigned)conf.tv_override_value>=(sizeof(modes)/sizeof(modes[0])))
          conf.tv_override_value=0;
        return modes[conf.tv_override_value]; 
      }
@@ -1612,7 +1615,7 @@
     conf.tv_enum_type+=change;
     if (conf.tv_enum_type<0)
         conf.tv_enum_type=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.tv_enum_type>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.tv_enum_type>=(sizeof(modes)/sizeof(modes[0])))
         conf.tv_enum_type=0;
     if (change) {
       conf.tv_override_koef=6;	
@@ -1630,7 +1633,7 @@
     conf.iso_override_koef+=change;
     if (conf.iso_override_koef<0)
         conf.iso_override_koef=0;
-    else if (conf.iso_override_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.iso_override_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.iso_override_koef=sizeof(modes)/sizeof(modes[0])-1;
     
     return modes[conf.iso_override_koef]; 
@@ -1654,7 +1657,7 @@
 
     conf.subj_dist_override_koef+=change;
     if (conf.subj_dist_override_koef<0) conf.subj_dist_override_koef=0;
-    else if (conf.subj_dist_override_koef>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.subj_dist_override_koef>=(sizeof(modes)/sizeof(modes[0])))
         conf.subj_dist_override_koef=sizeof(modes)/sizeof(modes[0])-1;
     
     return modes[conf.subj_dist_override_koef]; 
@@ -1753,7 +1756,7 @@
     conf.user_menu_enable+=change;
     if (conf.user_menu_enable<0)
         conf.user_menu_enable=(sizeof(modes)/sizeof(modes[0]))-1;
-    else if (conf.user_menu_enable>=(sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.user_menu_enable>=(sizeof(modes)/sizeof(modes[0])))
         conf.user_menu_enable=0;
 
     return modes[conf.user_menu_enable];
@@ -1764,7 +1767,7 @@
     static const int keys[]={0, KEY_SHOOT_HALF, KEY_SET }; 
     int i; 
  
-    for (i=0; i<sizeof(names)/sizeof(names[0]); ++i) { 
+    for (i=0; (unsigned)i<sizeof(names)/sizeof(names[0]); ++i) { 
         if (conf.video_af_key==keys[i]) { 
             break; 
         } 
@@ -1773,7 +1776,7 @@
     i+=change; 
     if (i<0) 
         i=(sizeof(names)/sizeof(names[0]))-1; 
-    else if (i>=(sizeof(names)/sizeof(names[0]))) 
+    else if ((unsigned)i>=(sizeof(names)/sizeof(names[0]))) 
         i=0; 
  
     conf.video_af_key = keys[i]; 
@@ -1785,7 +1788,7 @@
     conf.bad_pixel_removal+=change; 
     if (conf.bad_pixel_removal<0) 
         conf.bad_pixel_removal=(sizeof(modes)/sizeof(modes[0]))-1; 
-    else if (conf.bad_pixel_removal>=(sizeof(modes)/sizeof(modes[0]))) 
+    else if ((unsigned)conf.bad_pixel_removal>=(sizeof(modes)/sizeof(modes[0]))) 
         conf.bad_pixel_removal=0; 
  
     return lang_str(modes[conf.bad_pixel_removal]); 
@@ -1793,7 +1796,7 @@
  
 //-------------------------------------------------------------------
 void gui_update_script_submenu() {
-    register int p=0, i;
+    register unsigned int p=0, i;
 
     for (i=0; i<sizeof(script_submenu_items_top)/sizeof(script_submenu_items_top[0]); ++p, ++i) {
         script_submenu_items[p]=script_submenu_items_top[i];
@@ -1818,7 +1821,7 @@
  struct stat st;
  if (!filename) return;
  stat((char*)filename,&st);
- if (st.st_size!=hook_raw_size()) return;
+ if ((long)st.st_size!=hook_raw_size()) return;
  gui_mbox_init((int)"", LANG_RAW_DEVELOP_MESSAGE, MBOX_BTN_OK|MBOX_TEXT_CENTER, NULL);
  raw_prepare_develop((char*)filename);
 }
@@ -1888,7 +1891,7 @@
     conf.debug_shortcut_action += change;
     if (conf.debug_shortcut_action < 0) 
         conf.debug_shortcut_action = sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.debug_shortcut_action >= (sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.debug_shortcut_action >= (sizeof(modes)/sizeof(modes[0])))
         conf.debug_shortcut_action = 0;
     
     return modes[conf.debug_shortcut_action]; 
@@ -1900,7 +1903,7 @@
     conf.debug_display += change;
     if (conf.debug_display < 0) 
         conf.debug_display=sizeof(modes)/sizeof(modes[0])-1;
-    else if (conf.debug_display >= (sizeof(modes)/sizeof(modes[0])))
+    else if ((unsigned)conf.debug_display >= (sizeof(modes)/sizeof(modes[0])))
         conf.debug_display = 0;
     
     return modes[conf.debug_display]; 
@@ -1965,7 +1968,7 @@
 static volatile enum Gui_Mode gui_mode;
 static volatile int gui_restore;
 static volatile int gui_in_redraw;
-static int gui_splash, gui_splash_mode;
+static unsigned int gui_splash, gui_splash_mode;
 static char osd_buf[32];
 #ifdef OPTIONS_AUTOSAVE
 static Conf old_conf;
@@ -2744,7 +2747,8 @@
 
    {
 	static char sbuf[100];
-    int r,i, p, len;
+	unsigned len;
+    int r,i, p;
     if (conf.debug_display == DEBUG_DISPLAY_PROPS){
 
 	for (i=0;i<10;i++){
@@ -2958,7 +2962,7 @@
         "CHDK Firmware '" HDK_VERSION " " BUILD_NUMBER "'" , 
         "Build: " __DATE__ " " __TIME__ ,
         "Camera: " PLATFORM " - " PLATFORMSUB };
-    int i, l;
+	unsigned i, l;
     color cl = MAKE_COLOR(COLOR_RED, COLOR_WHITE);
 
     gui_splash_mode = (mode_get()&MODE_MASK);
@@ -2987,7 +2991,7 @@
       for(pos=0; pos<logo_size; pos++){
           char data = logo[pos];
           color c = color_lookup[(data>>5) & 0x07];
-          for(i=0; i<(data&0x1F)+1; i++){
+          for(i=0; i<(data&0x1FU)+1; i++){
               if (c!=0x00){
                   draw_pixel(offset_x+mx,offset_y+my,c);
               }
@@ -3279,7 +3283,7 @@
 	char buf[64];
 	int i;
 	int p;
-	int c;
+	int c = 0;
 
 
 	if( initialized )
@@ -3319,4 +3323,189 @@
 	initialized = 1;
 }
 
+#define NUM_params 256
+#define BLACKLIST_FILENAME "A/CHDK/DATA/BLACKLIST.PAR"
+static signed char *blacklist = 0;
+int shooting_get_param( int id )
+{
+	int r = 0;
+	int s = sizeof(r);
+	if( blacklist )
+	{
+		if( id < 0 || id >= NUM_params )
+		{
+			s = 0;
+		}
+		else
+		{
+			s = blacklist[id];
+		}
+	}
+	if( s )
+	{
+		get_parameter_data(id,&r,s);
+	}
+	return r;
+}
+
+void write_blacklist_file( const signed char* bl )
+{
+	int fd;
+	fd = open(BLACKLIST_FILENAME, O_RDWR|O_CREAT|O_TRUNC, 0777);
+	write(fd,bl,NUM_params);
+	close(fd);
+}
+
+void gui_compare_params(int arg)
+{
+	static int initialized = 0;
+	static int *params = 0;
+	char buf[64];
+	int i;
+	int p;
+	int c;
+	int fd;
+	int test = 0;
+
+	if( 0 == blacklist )
+	{ 
+		blacklist = malloc(NUM_params);
+		// blacklist creation/loading of next step wasn't done yet, lets have a look if...
+		// the file exists at all
+		struct stat s;
+		s.st_size = 0;
+
+		stat(BLACKLIST_FILENAME,&s);
+		if( s.st_size < NUM_params )
+		{ // either from another compile or broken in another way or not there or... well whatever
+			for(i = 0; i < NUM_params; ++i )
+			{ // initialize all to -8 meaning: not yet tested
+				blacklist[i] = -8;
+			}
+		}
+		else
+		{
+			// open and read the file
+			fd = open(BLACKLIST_FILENAME, O_RDONLY,0);
+			read(fd,blacklist,NUM_params);
+			close(fd);
+		}
+		/*
+		 * The following entries are possible with the said meaning in the
+		 * blacklist file:
+		 * -8 : This param has not yet been tested, you should do this
+		 * -4 : The last test was tried with reading 4 bytes and failed. Action to be taken: write 2
+		 * -2 : The last test was tried with reading 4 bytes and failed. Action to be taken: write 1
+		 * -1 : The last test was tried with reading 4 bytes and failed. Action to be taken: write 0
+		 *  0 : Not a single byte can ever be read from this location
+		 *  1 : Only ever read 1 byte from the location
+		 *  2 : Only ever read 2 bytes from the location
+		 *  4 : It is save to read 4 bytes from this location
+		 */
+		i = 0;
+		// skip all entries that have been tested already
+		while( i < NUM_params )
+		{
+			switch(blacklist[i])
+			{
+				case -8:
+					sprintf(buf,"Testing param %d read 1",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// need to test, so... note in the array
+					blacklist[i] = -1;
+					write_blacklist_file(blacklist);
+					get_parameter_data(i,&test,1);
+
+					sprintf(buf,"Testing param %d read 2",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// no crash? try more!
+					blacklist[i] = -2;
+					write_blacklist_file(blacklist);
+					get_parameter_data(i,&test,2);
+
+					sprintf(buf,"Testing param %d read 4",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// no crash? try more!
+					blacklist[i] = -4;
+					write_blacklist_file(blacklist);
+					get_parameter_data(i,&test,4);
+
+					sprintf(buf,"Testing param %d was successfull up to 4",i);
+					draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+					// still no crash? wow, nice
+					blacklist[i] = 4;
+					write_blacklist_file(blacklist);
+					break;
+				case -4: // last test failed, record this
+					blacklist[i] = 2;
+					break;
+				case -2: // last test failed, record this
+					blacklist[i] = 1;
+					break;
+				case -1: // last test failed, record this
+					blacklist[i] = 0;
+					break;
+				case 0:
+				case 1:
+				case 2:
+				case 4:
+				default:
+					// this one is safe...
+					break;
+			}
+			// advance to the next...
+			++i;
+		}
+		// we went here without any crashes, that means the blacklist is
+		// complete now
+		write_blacklist_file(blacklist);
+	}
+	if( 0 == params )
+	{
+		params = malloc(NUM_params * sizeof(int));
+	}
+
+	if( initialized )
+	{ // we have previous data set! do a comparison
+		c = 0;
+		for( i = 0; i < NUM_params; ++i )
+		{
+			p = shooting_get_param(i);
+			if( params[i] != p )
+			{
+				++c;
+				sprintf(buf,"%4d is %8d was %8d",i,p,params[i]);
+				draw_string(16,16*c,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+			}
+			params[i] = p;
+			if( c == 12 )
+			{
+				++c;
+				sprintf(buf,"%s","Waiting 10 Seconds");
+				draw_string(16,16*c,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+				msleep(10000);
+				c = 0;
+			}
+		}
+		++c;
+		sprintf(buf,"%s","Waiting 10 Seconds");
+		draw_string(16,16*c,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+		msleep(10000);
+	}
+	else
+	{
+		// no previous data was set so we save the data initially
+		for( i = 0; i < NUM_params; ++i )
+		{
+#if 0
+			sprintf(buf,"About to read %d",i);
+			draw_string(16,16,buf,MAKE_COLOR(COLOR_BLACK,COLOR_YELLOW));
+			msleep(1000);
 #endif
+			params[i] = shooting_get_param(i);
+		}
+	}
+	initialized = 1;
+}
+#endif
+// vim: tabstop=4 shiftwidth=4
Index: core/gui_mpopup.c
===================================================================
--- core/gui_mpopup.c	(Revision 701)
+++ core/gui_mpopup.c	(Arbeitskopie)
@@ -41,7 +41,7 @@
 
 //-------------------------------------------------------------------
 void gui_mpopup_init(const unsigned int flags, void (*on_select)(unsigned int actn)) {
-    int i;
+    unsigned int i;
 
     mpopup_actions_num = 0;
     for (i=0; i<ACTIONSNUM && mpopup_actions_num<MAX_ACTIONS; ++i) {
